#!/usr/bin/python
import os
import random
from time import sleep
from mcp23017 import mcp23017,pin

lockfile_path='/tmp/openhab.lck'

mcp23017_1=mcp23017(0,0x20)

#Schalter an und aus
swon=pin(mcp23017_1,"gpiob",1)
swoff=pin(mcp23017_1,"gpiob",0)
#Schalter a bis e
swa=pin(mcp23017_1,"gpioa",2)
swb=pin(mcp23017_1,"gpioa",1)
swc=pin(mcp23017_1,"gpioa",0)
swd=pin(mcp23017_1,"gpiob",3)
swe=pin(mcp23017_1,"gpiob",2)
#Senden
swte=pin(mcp23017_1,"gpiob",7)
#Pins fuer Hausadresse
swa1=pin(mcp23017_1,"gpioa",7)
swa2=pin(mcp23017_1,"gpioa",6)
swa3=pin(mcp23017_1,"gpioa",5)
swa4=pin(mcp23017_1,"gpioa",4)
swa5=pin(mcp23017_1,"gpioa",3)

def set_houseid(id):
    id=str(id)
    if len(id)==5:
        if id[0]=="1":
            swa1.disable()
        else:
            swa1.setx()
        if id[1]=="1":
            swa2.disable()
        else:
            swa2.setx()
        if id[2]=="1":
            swa3.disable()
        else:
            swa3.setx()
        if id[3]=="1":
            swa4.disable()
        else:
            swa4.setx()
        if id[4]=="1":
            swa5.disable()
        else:
            swa5.setx()

def islocked():
    return os.path.exists(lockfile_path)
    try:
        lockfile=(lockfile_path, 'r')
        return True
    except:
        return False

def setlock():
    try:
        pid=os.getpid
        lockfile=os.open(lockfile_path, os.O_EXCL|os.O_WRONLY|os.O_CREAT)
        os.write(lockfile,str(pid))
        os.close(lockfile)
        return True
    except:
        return False

def releaselock():
    try:
        os.remove(lockfile_path)
        return True
    except:
        return False


def waitlock():
    sleep(random.uniform(0.0,0.15))
    while not setlock():
       print("waitong for lock")
       sleep(0.05)
    #if islocked():
    #    locked=True
    #    while locked == True:
    #       sleep(random.uniform(0.0,0.15))
    #       locked=islocked()

#send_data() enables the TE pin for 0.5 seconds
def send_data():
    swte.enable()
    sleep(0.8)
    swte.disable()
    #sleep(0.1)


def turn_on(switch,houseid):
   waitlock()
   #setlock()
   set_houseid(houseid)
   swon.disable()
   switch.disable()
   sleep(0.01)
   send_data()
   swon.setx()
   switch.setx()
   releaselock()


def turn_off(switch,houseid):
   waitlock()
   #setlock()
   set_houseid(houseid)
   swoff.disable()
   switch.disable()
   sleep(0.01)
   send_data()
   swoff.setx()
   switch.setx()
   releaselock()

